%{
  #include <stdio.h>
  extern void yyerror(char*);
  extern int yylex();
%}

%token number sin cos DONE

%start S

%%

S : Expr DONE { printf("Done!\n"); } ;
Expr : Term | Expr '+' Term | Expr '-' Term ;
Term: Faktor | Term '*' Faktor | Term '/' Faktor ;
Faktor: number | '(' Expr ')' | sin '(' Expr ')' | cos '(' Expr ')' ;

%%

void yyerror(char *s) {
    printf("Parse error: '%s'\n", s);
}

int main() {
  while (1) {
    printf("Before yyparse...\n");
    yyparse();
    printf("After yyparse\n");
  }

  return 0;
}
